// These tests are examples to get you started on how how to test
// Lightning Web Components using the Jest testing framework.
//
// See the LWC Recipes Open Source sample application for many other
// test scenarios and best practices.
//
// https://github.com/trailheadapps/lwc-recipes-oss

import { createElement } from 'lwc';
import MyGreeting from 'c/greeting';

describe('my-greeting', () => {
    afterEach(() => {
        // The jsdom instance is shared across test cases in a single file so reset the DOM
        while (document.body.firstChild) {
            document.body.removeChild(document.body.firstChild);
        }
    });

    it('contains a div that controls animation.', () => {
        const SPEED_CLASS_VALUES = ['fade-slow', 'fade-fast', 'fade-medium'];

        const element = createElement('my-greeting', {
            is: MyGreeting
        });
        document.body.appendChild(element);

        // Get div element
        const divEl = element.shadowRoot.querySelector('div');

        expect(
            SPEED_CLASS_VALUES.indexOf(divEl.className)
        ).toBeGreaterThanOrEqual(0);
    });

    it('contains a span tag that displays the greeting message.', () => {
        const INITIAL_GREETING = 'Hello';

        const element = createElement('my-greeting', {
            is: MyGreeting
        });
        document.body.appendChild(element);

        // Get span element
        const spanEl = element.shadowRoot.querySelector('span');

        expect(spanEl.textContent).toBe(INITIAL_GREETING);
    });
});


----
import { LightningElement, track, api } from 'lwc';

const greetings = [
    'Hello',
    'Bonjour',
    '你好',
    'Hola',
    'Привет',
    'こんにちは',
    'Guten Tag',
    'ጤና ይስጥልኝ',
    'Ciao',
    'नमस्ते',
    '안녕하세요'
];
const SPEED_CLASS_MAP = {
    slow: 'fade-slow',
    fast: 'fade-fast',
    medium: 'fade-medium'
};
const DEFAULT_SPEED = 'medium';

export default class Greeting extends LightningElement {
    @track animationSpeed = DEFAULT_SPEED;
    @track index = 0;
    @track isAnimating = true;

    @api
    set speed(value) {
        if (SPEED_CLASS_MAP.hasOwnProperty(value)) {
            this.animationSpeed = value;
        } else {
            this.animationSpeed = DEFAULT_SPEED;
        }
        this.isAnimating = true;
    }

    // Return the internal speed property
    get speed() {
        return this.animationSpeed;
    }

    // Get the current greeting
    get greeting() {
        return greetings[this.index];
    }

    // Map slow, medium, fast to CSS Animations
    get animationClass() {
        if (this.isAnimating) {
            return SPEED_CLASS_MAP[this.speed];
        }
        return 'hide';
    }

    //Handle the animation ending, update to next hello
    handleAnimationEnd() {
        this.isAnimating = false;
        this.index = (this.index + 1) % greetings.length;

        setTimeout(() => this.updateGreeting(), 500);
    }

    // Update to the next greeting and start animating
    updateGreeting() {
        this.isAnimating = true;
    }
}
----
<template>
    <div class={animationClass} onanimationend={handleAnimationEnd}>
        <span class="greet" align="center">{greeting}</span>
    </div>
</template>
---
    .greet {
        font-size: xx-large;
        text-align: center;
    }

    .fade-fast {
        opacity: 0;
        animation: fade-in 1s;
    }

    .fade-slow {
        opacity: 0;
        animation: fade-in 5s;
    }

    .fade-medium {
        opacity: 0;
        animation: fade-in 2s;
    }

    @keyframes fade-in {
        0% {
            opacity: 0;
        }
        35% {
            opacity: 1;
        }
        65% {
            opacity: 1;
        }
        100% {
            opacity: 0;
        }
    }

    .hide {
        opacity: 0;
    }
